<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class MY_Controller extends Controller {

    protected $template = 'template';
    protected $template_data = array();
    protected $user_id;
    protected $username;

    function __construct() {
	parent::__construct();

	$this->load->library('session');
	$this->load->library('simplelogin');
	$this->load->helper('url');

	if (!$this->simplelogin->is_authenticated()) {
	    $this->set_template_data('is_auth', false);
	    if (!($this->uri->segment(1)=='auth' && $this->uri->segment(2)=='index')) {
		redirect('auth/index');
	    }
	}
	else {
	    $this->user_id = $this->session->userdata('id');
	    $this->username = $this->session->userdata('username');
	    $this->set_template_data('is_auth', true);
	    $this->set_template_data('username', $this->username);
	}
    }

    protected function set_template_part($part, $view, $data = array()) {
	$this->template_data[$part] = $this->load->view($view, $data, true);
    }

    protected function set_template_data($part, $data) {
	$this->template_data[$part] = $data;
    }

    protected function display_template($view = null, $data = array()) {
	if (!is_null($view)) {
	    $this->set_template_part('content', $view, $data);
	}
	$this->load->view($this->template, $this->template_data);
    }

}