<?php

class Images_Model extends Model {
	
    public function __construct() {
	parent::__construct();
	$this->load->database();
    }

    public function get_images($album_id = '') {
	$sql ="select id, nev from images
		where
		    album_id = ?";

	$query = $this->db->query($sql, array($album_id));

	return $query->result_array();
    }

    public function get_image($id = null) {
	$sql =
	    "select id, nev, data, thumb
	    from images
	    where id = ?";
	$result = $this->db->query($sql, array($id));

	return $result->row_array();
    }

    public function insert_image($nev = null, $data_filename = null, $album_id = null) {
	//Thumbnail eloallitasa
	$data_thumb_filename = $this->_create_thumb($data_filename);

	/*
	$data = file_get_contents($data_filename);
	$data_thumb = file_get_contents($data_thumb_filename);

	return $this->db->insert(
	    'images',
	    array(
		'nev'		 => $nev,
		'data'		 => $data,
		'thumb'		 => $data_thumb,
		'album_id'	 => $album_id
	    )
	);
	*/

	return $this->_save_blob($nev, $data_filename, $data_thumb_filename, $album_id);
    }

    private function _save_blob($nev = null, $data_filename = null, $data_thumb_filename = null, $album_id = null) {
	$conn = $this->db->conn_id;
	$sql = "insert into images
		    (nev, data, thumb, album_id) values (?, ?, ?, ?)";
	if ($stmt = mysqli_prepare($conn, $sql)) {
	    mysqli_bind_param($stmt, 'sbbi', $nev, $data, $data_thumb, $album_id);

	    $fp = fopen($data_filename, "r");
	    while (!feof($fp)) {
		mysqli_stmt_send_long_data($stmt, 1, fread($fp, 8192));
	    }
	    fclose($fp);

	    $fp = fopen($data_thumb_filename, "r");
	    while (!feof($fp)) {
		mysqli_stmt_send_long_data($stmt, 2, fread($fp, 8192));
	    }
	    fclose($fp);

	    $result = mysqli_stmt_execute($stmt);

	    mysqli_stmt_close($stmt);

	    return $result;
	}

	return false;
    }

    private function _create_thumb($source_filename) {
	$config = array(
	    'image_library' => 'gd2',
	    'source_image' => $source_filename,
	    'create_thumb' => TRUE,
	    'maintain_ratio' => TRUE,
	    'width' => 100,
	    'height' => 67
	);

	$this->load->library('image_lib', $config);

	if ($this->image_lib->resize()) {
	    return $source_filename . '_thumb';
	}

	return false;
    }
}
